> ## Documentation Index
> Fetch the complete documentation index at: https://docs.querying.ai/llms.txt
> Use this file to discover all available pages before exploring further.

# Walmart API

> Walmart の商品を検索し、商品ページを読み取って JSON で受け取ります。検索結果の順位と価格、評価、レビュー数、商品ページの価格、在庫、販売者、画像、仕様、オプションを返します。

Walmart（walmart.com）の商品を検索し、商品ページを非同期タスク API で読み取ります。`COMMERCE_SERP` に `site` `walmart` を指定すると検索結果の商品をストアの順に受け取り、`COMMERCE_PRODUCT` に商品の `url` を渡すとその商品を 1 つ読み取ります。完了した検索または商品ページ 1 件につき **0.5 クレジット**です。

## 検索

```bash theme={"theme":"css-variables"}
curl -X POST https://api.querying.ai/v1/async/task \
  -H "Authorization: Bearer $QUERYING_API_KEY" \
  -H "Content-Type: application/json" \
  -d '{ "taskType": "COMMERCE_SERP", "payload": { "site": "walmart", "query": "wireless earbuds", "limit": 3 } }'
```

タスクを送信したあと、`GET /v1/async/task/{id}` をポーリングするか Webhook で受け取ります。[非同期タスク](https://docs.querying.ai/ja/concepts/async-tasks.md)を参照してください。

### パラメータ

* `site`: 必須。`walmart` です。
* `query`: 必須。検索語で、1-500 文字です。
* `limit`: 任意の整数、1-40。デフォルトは 20 です。
* `country`: 任意。デフォルトはストアの国の `US` です。ほかの国は `422 REGION_UNSUPPORTED` で拒否されます。

受け付けるペイロードフィールドは上記のみです。`include` は省略してください。`include: {}` でも、クレジットを確保する前に `payload.include` の `422 VALIDATION_ERROR` を返します。

### レスポンス例

```json theme={"theme":"css-variables"}
{
  "site": "walmart",
  "query": "wireless earbuds",
  "country": "US",
  "returnedCount": 3,
  "products": [
    {
      "rank": 1,
      "productId": "19988265343",
      "title": "Wireless Earbuds, 40Hour Battery Life, IPX6 Water Resistance, Touch Controls, for Cycling, Running and Working Out",
      "url": "https://www.walmart.com/ip/Wireless-Earbuds-40-Hour-Battery-Life-IPX6-Water-Resistance-Touch-Controls-for-Cycling-Running-and-Working-Out/19988265343",
      "price": 23.28,
      "currency": "USD",
      "rating": 4.6,
      "reviewCount": 60,
      "imageUrl": "https://i5.walmartimages.com/seo/Wireless-Earbuds-40-Hour-Battery-Life-IPX6-Water-Resistance-Touch-Controls-for-Cycling-Running-and-Working-Out_9d00bfbd-1199-482e-8683-26c939d8a25e.a140f5c2f33ebe4c9d64552b6d7c8f7b.jpeg"
    },
    {
      "rank": 2,
      "productId": "20857668382",
      "title": "Bloydek Wireless Earbuds In-Ear Earbuds,Bluetooth 5.4,Strong Noise Cancellation,IPX5 Waterproof,Touch Control,Type-C Fast Charge,Gaming Low Latency",
      "url": "https://www.walmart.com/ip/Bloydek-Wireless-Bluetooth-In-Ear-Earbuds-Bluetooth-5-4-Strong-Noise-Cancellation-IPX5-Waterproof-Touch-Control-Type-C-Fast-Charge-Gaming-Low-Latency/20857668382",
      "price": 16.99,
      "currency": "USD",
      "rating": 5,
      "reviewCount": 81,
      "imageUrl": "https://i5.walmartimages.com/seo/Bloydek-Wireless-Bluetooth-In-Ear-Earbuds-Bluetooth-5-4-Strong-Noise-Cancellation-IPX5-Waterproof-Touch-Control-Type-C-Fast-Charge-Gaming-Low-Latency_30bb2f49-e592-45bf-ba5e-df79256d9612.d5a461ed3464c2970b69385668a19f3a.jpeg?odnHeight=180&odnWidth=180&odnBg=FFFFFF"
    },
    {
      "rank": 3,
      "productId": "7678011381",
      "title": "Clip on Earbuds Open Ear Wireless Bluetooth 5.4 Headphones with Mic,50H Play,Noise Cancelling,Waterproof,Sports Ear Buds,Lightweight Open Ear Headphones with C-Shaped Bridge,Workouts (Black)",
      "url": "https://www.walmart.com/ip/Clip-Earbuds-Open-Ear-Wireless-Bluetooth-5-4-Headphones-Mic-50H-Play-Noise-Cancelling-Waterproof-Sports-Ear-Buds-Lightweight-Open-Ear-Headphones-C-Sh/7678011381",
      "price": 13.99,
      "currency": "USD",
      "rating": 4.2,
      "reviewCount": 238,
      "imageUrl": "https://i5.walmartimages.com/seo/Clip-Earbuds-Open-Ear-Wireless-Bluetooth-5-4-Headphones-Mic-50H-Play-Noise-Cancelling-Waterproof-Sports-Ear-Buds-Lightweight-Open-Ear-Headphones-C-Sh_3f7e97de-8440-4292-b33e-1aa08be84400.a047bf99a987ed55f7c32d597934768d.jpeg?odnHeight=180&odnWidth=180&odnBg=FFFFFF"
    }
  ]
}
```

### 結果フィールド

* `site`、`query`、`country` はリクエストの値です。`returnedCount` は `products` の件数です。
* 各商品は `rank`、`productId`、`title`、`url` を含みます。`productId` はストア独自の商品 ID です。`rank` はストアのデフォルトの並び順で、ストアが広告と表示した商品は除きます。
* `price`、`rating`、`reviewCount`、`imageUrl` は、検索結果の画面に表示されている場合に含みます。`price` は商品ごとの `currency`（ISO 4217）の数値で、容量ごとに価格が異なる場合は最も低い価格です。
* `rating` は 5 点満点です。 999+ のように省略表示されたレビュー数は含みません。
* 検索ごとに、ストアの検索結果の 1 ページ目から商品を取得します。

## 商品ページ

```bash theme={"theme":"css-variables"}
curl -X POST https://api.querying.ai/v1/async/task \
  -H "Authorization: Bearer $QUERYING_API_KEY" \
  -H "Content-Type: application/json" \
  -d '{ "taskType": "COMMERCE_PRODUCT", "payload": { "url": "https://www.walmart.com/ip/Wireless-Earbuds-40-Hour-Battery-Life-IPX6-Water-Resistance-Touch-Controls-for-Cycling-Running-and-Working-Out/19988265343" } }'
```

### パラメータ

* `url`: 必須。Walmart の商品ページで、2,048 文字以内です。形式は `walmart.com/ip/{name}/{id}` です。検索結果の商品 `url` はそのまま渡せます。トラッキングコードなど結果に影響しないパラメータは読み取り前に取り除きます。
* `country`: 任意。デフォルトはページの国の `US` です。ほかの国は `422 REGION_UNSUPPORTED` で拒否されます。

受け付けるペイロードフィールドは上記のみです。`include` は省略してください。`include: {}` でも、クレジットを確保する前に `payload.include` の `422 VALIDATION_ERROR` を返します。

### レスポンス例

```json theme={"theme":"css-variables"}
{
  "site": "walmart",
  "country": "US",
  "url": "https://www.walmart.com/ip/Wireless-Earbuds-40-Hour-Battery-Life-IPX6-Water-Resistance-Touch-Controls-for-Cycling-Running-and-Working-Out/19988265343",
  "productId": "19988265343",
  "title": "Wireless Earbuds, 40‑Hour Battery Life, IPX6 Water Resistance, Touch Controls, for Cycling, Running and Working Out",
  "brand": "Rovisigns",
  "price": 23.28,
  "listPrice": 39.99,
  "currency": "USD",
  "inStock": true,
  "seller": "DEYU",
  "rating": 4.6,
  "reviewCount": 60,
  "images": [
    "https://i5.walmartimages.com/seo/Wireless-Earbuds-40-Hour-Battery-Life-IPX6-Water-Resistance-Touch-Controls-for-Cycling-Running-and-Working-Out_9d00bfbd-1199-482e-8683-26c939d8a25e.a140f5c2f33ebe4c9d64552b6d7c8f7b.jpeg",
    "https://i5.walmartimages.com/asr/13c98513-e5c4-4247-9a11-5cdef37188ce.afb045dc15d75519e29ab72440ca2968.jpeg"
  ],
  "description": "Immersive Rich Audio & Clear Calls：Our open-ear earbuds Adopts innovative quad-speaker structure with dual drivers per earbud, equipped with 15mm large-diaphragm dynamic drivers and dedicated…",
  "specs": [
    { "name": "Battery life", "value": "60 h" },
    { "name": "Headphone style", "value": "In-Ear" },
    { "name": "Noise control technology", "value": "Passive Noise Cancellation" }
  ],
  "categories": [
    "Electronics",
    "Audio",
    "Headphones",
    "Shop Headphones by Type",
    "Earbuds and In-Ear Headphones"
  ],
  "gtin": "607616049364"
}
```

### 結果フィールド

* `site`、`country`、`url`、`productId` でページを識別します。`url` は読み取ったページで、`productId` は検索結果の ID と同じです。
* `title` は常に含みます。`brand`、`price`、`listPrice`、`currency`、`inStock`、`seller`、`rating`、`reviewCount`、`images`、`description`、`specs`、`options`、`categories`、`gtin` は、ページに表示されている場合に含みます。
* `price` は、クーポンと送料を適用する前にページが最初に表示する購入価格で、`currency`（ISO 4217）の値です。 `listPrice` はページが取り消し線で表示する通常価格で、`price` より高い場合だけ含みます。 `inStock` は在庫の有無です。 `seller` は販売者です。
* `rating` は小数第 2 位までの 5 点満点の評価です。 `reviewCount` はレビュー数です。
* `images` は商品ギャラリーの写真を、ページの順に最大 30 枚含みます。
* `description` は段落ごとに 1 行のプレーンテキストで、最大 10,000 文字です。画像の中にしかない文字は含みません。
* `specs` は商品詳細の `{ name, value }` の組を最大 100 個含みます。 `options` はサイズや色などの選択肢を最大 20 個、選択肢ごとに `values` を最大 100 個含みます。ほかのフィールドは、ページが最初に選択している選択肢のものです。 `categories` は最も広いカテゴリから最も狭いカテゴリまでの、最大 10 階層です。 `gtin` はページに記載された UPC、EAN、JAN です。

## エラーと課金

* 商品が 1 つもない検索は、失敗したタスクとして終了します。
* ストアが 404 または 410 で応答する商品ページ（削除された商品など）は `PAGE_UNAVAILABLE` で終了し、メッセージにストアの応答が入ります。ストアが 403、412、429、435 で読み取りを拒否した場合、タスクは待機して最大 6 分間再試行します。ほかの読み取り失敗と、それより長く続く拒否は `ENGINE_NO_RESULT` で終了します。
* 課金は完了したタスクだけで、検索または商品ページ 1 件につき 0.5 クレジットです。

## 関連

* [Amazon](https://docs.querying.ai/ja/engines/amazon.md)
* [Target](https://docs.querying.ai/ja/engines/target.md)
* [eBay](https://docs.querying.ai/ja/engines/ebay.md)
* [Commerce のストア一覧](https://docs.querying.ai/ja/engines/overview.md#commerce)
* [クレジットと上限](https://docs.querying.ai/ja/concepts/credits-and-limits.md)


This documentation is built and hosted on [Mintlify](https://mintlify.com), a developer documentation platform.